<html>
<head>
<title>OgreGLSLESPreprocessor.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_740c5ae02f3e58539fc77518d7d26661.html">GLES2</a>      </li>
      <li class="navelem"><a class="el" href="dir_869fcd4d0767bf0c6544e0566078ca07.html">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_9c8668f5b14e7779923b4ed363e11a4e.html">GLSLES</a>      </li>
      <li class="navelem"><a class="el" href="dir_84d626bd39fc7a71e1d66527f3ce1f64.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLSLESPreprocessor.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLSLESPreprocessor_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __OGRE_CPREPROCESSOR_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __OGRE_CPREPROCESSOR_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;string.h&gt;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00061"></a>00061 <span class="keyword">class </span>CPreprocessor
<a name="l00062"></a>00062 {
<a name="l00076"></a>00076     <span class="keyword">class </span>Token
<a name="l00077"></a>00077     {
<a name="l00078"></a>00078     <span class="keyword">public</span>:
<a name="l00079"></a><a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1c">00079</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1c">Kind</a>
<a name="l00080"></a>00080         {
<a name="l00081"></a>00081             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1ca1b56d7bb41a2f877f8c705c010605a44">TK_EOS</a>,          <span class="comment">// End of input stream</span>
<a name="l00082"></a>00082             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1cae84c9655e8fb1bed1ab7a43f52a14bb3">TK_ERROR</a>,        <span class="comment">// An error has been encountered</span>
<a name="l00083"></a>00083             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1ca90a825a75631104512c23e9813a90589">TK_WHITESPACE</a>,   <span class="comment">// A whitespace span (but not newline)</span>
<a name="l00084"></a>00084             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1ca22e637e326bfeb9f62721c49ba3262d8">TK_NEWLINE</a>,      <span class="comment">// A single newline (CR &amp; LF)</span>
<a name="l00085"></a>00085             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1ca016b12f5798c3c8701177bfb7bbc64a0">TK_LINECONT</a>,     <span class="comment">// Line continuation (&#39;\&#39; followed by LF)</span>
<a name="l00086"></a>00086             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1ca60713da5682b73019316730be1c2957b">TK_NUMBER</a>,       <span class="comment">// A number</span>
<a name="l00087"></a>00087             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1cac5863dbffefda4adcbf731d2c3cceff9">TK_KEYWORD</a>,      <span class="comment">// A keyword</span>
<a name="l00088"></a>00088             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1ca039e0f19708e47b1c1aee1ccafac9816">TK_PUNCTUATION</a>,  <span class="comment">// A punctuation character</span>
<a name="l00089"></a>00089             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1ca56e64e4e477e2ca292f131ccbd232da7">TK_DIRECTIVE</a>,    <span class="comment">// A preprocessor directive</span>
<a name="l00090"></a>00090             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1cac24036bea9072a75c73760c8ab056aa5">TK_STRING</a>,       <span class="comment">// A string</span>
<a name="l00091"></a>00091             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1ca7877a16275419ba7ece4ccdf70a8c5a0">TK_COMMENT</a>,      <span class="comment">// A block comment</span>
<a name="l00092"></a>00092             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1caebd430b7e45505d02dd484f265742fbd">TK_LINECOMMENT</a>,  <span class="comment">// A line comment</span>
<a name="l00093"></a>00093             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1ca43924d84574e3eea272159d26e6274f9">TK_TEXT</a>          <span class="comment">// An unparsed text (cannot be returned from GetToken())</span>
<a name="l00094"></a>00094         };
<a name="l00095"></a>00095 
<a name="l00097"></a>00097         <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1c">Kind</a> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#ab208b6c5fb1d8e481366017fa884c2fa" title="Token type.">Type</a>;
<a name="l00099"></a>00099         <span class="keyword">mutable</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a49bc735f943a3c3805ebc28877a4a2f5" title="True if string was allocated (and must be freed)">Allocated</a>;
<a name="l00100"></a>00100         <span class="keyword">union</span>
<a name="l00101"></a>00101         {
<a name="l00103"></a>00103             <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#aa5ad3352307408c8a14236970bc1f81c" title="A pointer somewhere into the input buffer.">String</a>;
<a name="l00105"></a>00105             <span class="keywordtype">char</span> *<a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a82c26673a4129277ee31c410e3f5ca1e" title="A memory-allocated string.">Buffer</a>;
<a name="l00106"></a>00106         };
<a name="l00108"></a>00108         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a31cec35397868cf6bce6b1ea18ed8bff" title="Token length in bytes.">Length</a>;
<a name="l00109"></a>00109 
<a name="l00110"></a><a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a9a2ba4e5633501ae1dbe13c4ae0add8b">00110</a>         <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a9a2ba4e5633501ae1dbe13c4ae0add8b">Token</a> () : <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a49bc735f943a3c3805ebc28877a4a2f5" title="True if string was allocated (and must be freed)">Allocated</a> (0), <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> (NULL)
<a name="l00111"></a>00111         { }
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a4eba649dd171b4b340229d4f06adef08">00113</a>         <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a9a2ba4e5633501ae1dbe13c4ae0add8b">Token</a> (<a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1c">Kind</a> iType) : <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#ab208b6c5fb1d8e481366017fa884c2fa" title="Token type.">Type</a> (iType), <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a49bc735f943a3c3805ebc28877a4a2f5" title="True if string was allocated (and must be freed)">Allocated</a> (0), <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> (NULL)
<a name="l00114"></a>00114         { }
<a name="l00115"></a>00115 
<a name="l00116"></a><a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a118b97af680a2fbc94c23b90c063bc91">00116</a>         <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a9a2ba4e5633501ae1dbe13c4ae0add8b">Token</a> (<a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a10b32d342fb68c86c5dda3bf103fec1c">Kind</a> iType, <span class="keyword">const</span> <span class="keywordtype">char</span> *iString, <span class="keywordtype">size_t</span> iLength) :
<a name="l00117"></a>00117             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#ab208b6c5fb1d8e481366017fa884c2fa" title="Token type.">Type</a> (iType), <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a49bc735f943a3c3805ebc28877a4a2f5" title="True if string was allocated (and must be freed)">Allocated</a> (0), <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> (iString), <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a31cec35397868cf6bce6b1ea18ed8bff" title="Token length in bytes.">Length</a> (iLength)
<a name="l00118"></a>00118         { }
<a name="l00119"></a>00119 
<a name="l00120"></a><a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#abbbeb51aee6894370a0a3d4be64c89f6">00120</a>         <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a9a2ba4e5633501ae1dbe13c4ae0add8b">Token</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html" title="A input token.">Token</a> &amp;iOther)
<a name="l00121"></a>00121         {
<a name="l00122"></a>00122             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#ab208b6c5fb1d8e481366017fa884c2fa" title="Token type.">Type</a> = iOther.Type;
<a name="l00123"></a>00123             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a49bc735f943a3c3805ebc28877a4a2f5" title="True if string was allocated (and must be freed)">Allocated</a> = iOther.Allocated;
<a name="l00124"></a>00124             iOther.Allocated = 0; <span class="comment">// !!! not quite correct but effective</span>
<a name="l00125"></a>00125             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> = iOther.String;
<a name="l00126"></a>00126             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a31cec35397868cf6bce6b1ea18ed8bff" title="Token length in bytes.">Length</a> = iOther.Length;
<a name="l00127"></a>00127         }
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#ab0aa037a7a6a7124d0d37535d3aa33a0">00129</a>         <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#ab0aa037a7a6a7124d0d37535d3aa33a0">~Token</a> ()
<a name="l00130"></a>00130         { <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a49bc735f943a3c3805ebc28877a4a2f5" title="True if string was allocated (and must be freed)">Allocated</a>) free (<a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a82c26673a4129277ee31c410e3f5ca1e" title="A memory-allocated string.">Buffer</a>); }
<a name="l00131"></a>00131 
<a name="l00133"></a><a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a49f9a100c46dc81a843919d6a75c4764">00133</a>         <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html" title="A input token.">Token</a> &amp;<a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a49f9a100c46dc81a843919d6a75c4764" title="Assignment operator.">operator = </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html" title="A input token.">Token</a> &amp;iOther)
<a name="l00134"></a>00134         {
<a name="l00135"></a>00135             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a49bc735f943a3c3805ebc28877a4a2f5" title="True if string was allocated (and must be freed)">Allocated</a>) free (<a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a82c26673a4129277ee31c410e3f5ca1e" title="A memory-allocated string.">Buffer</a>);
<a name="l00136"></a>00136             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#ab208b6c5fb1d8e481366017fa884c2fa" title="Token type.">Type</a> = iOther.Type;
<a name="l00137"></a>00137             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a49bc735f943a3c3805ebc28877a4a2f5" title="True if string was allocated (and must be freed)">Allocated</a> = iOther.Allocated;
<a name="l00138"></a>00138             iOther.Allocated = 0; <span class="comment">// !!! not quite correct but effective</span>
<a name="l00139"></a>00139             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> = iOther.String;
<a name="l00140"></a>00140             <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a31cec35397868cf6bce6b1ea18ed8bff" title="Token length in bytes.">Length</a> = iOther.Length;
<a name="l00141"></a>00141             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00142"></a>00142         }
<a name="l00143"></a>00143 
<a name="l00145"></a>00145         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#af0f44a71d6f4309deb721d35af353144" title="Append a string to this token.">Append</a> (<span class="keyword">const</span> <span class="keywordtype">char</span> *iString, <span class="keywordtype">size_t</span> iLength);
<a name="l00146"></a>00146 
<a name="l00148"></a>00148         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#af0f44a71d6f4309deb721d35af353144" title="Append a string to this token.">Append</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html" title="A input token.">Token</a> &amp;iOther);
<a name="l00149"></a>00149 
<a name="l00151"></a>00151         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a1191145d8656978e4d0b3021cfc7849f" title="Append given number of newlines to this token.">AppendNL</a> (<span class="keywordtype">int</span> iCount);
<a name="l00152"></a>00152 
<a name="l00154"></a>00154         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a5ee810919549977009b0f8428ef78ebe" title="Count number of newlines in this token.">CountNL</a> ();
<a name="l00155"></a>00155 
<a name="l00157"></a>00157         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a395e05f47975f95ed6ed062ad3128a36" title="Get the numeric value of the token.">GetValue</a> (<span class="keywordtype">long</span> &amp;oValue) <span class="keyword">const</span>;
<a name="l00158"></a>00158 
<a name="l00160"></a>00160         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a123db5f492dc4900243844af056d6cfe" title="Set the numeric value of the token.">SetValue</a> (<span class="keywordtype">long</span> iValue);
<a name="l00161"></a>00161 
<a name="l00163"></a><a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a523d17a93ef1ba9fe6ec15d48201bc8a">00163</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a523d17a93ef1ba9fe6ec15d48201bc8a" title="Test two tokens for equality.">operator == </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html" title="A input token.">Token</a> &amp;iOther)
<a name="l00164"></a>00164         {
<a name="l00165"></a>00165             <span class="keywordflow">if</span> (iOther.Length != <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a31cec35397868cf6bce6b1ea18ed8bff" title="Token length in bytes.">Length</a>)
<a name="l00166"></a>00166                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00167"></a>00167             <span class="keywordflow">return</span> (memcmp (<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, iOther.String, <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html#a31cec35397868cf6bce6b1ea18ed8bff" title="Token length in bytes.">Length</a>) == 0);
<a name="l00168"></a>00168         }
<a name="l00169"></a>00169     };
<a name="l00170"></a>00170 
<a name="l00172"></a>00172     <span class="keyword">class </span>Macro
<a name="l00173"></a>00173     {
<a name="l00174"></a>00174     <span class="keyword">public</span>:
<a name="l00176"></a>00176         Token <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#aaa4db807c57ea970482b85adb2f61b7b" title="Macro name.">Name</a>;
<a name="l00178"></a>00178         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#af98d6c5e1e691dc809143ec71d07461b" title="Number of arguments.">NumArgs</a>;
<a name="l00180"></a>00180         Token *<a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#ab5237af20d6e7d79920b264f6890de28" title="The names of the arguments.">Args</a>;
<a name="l00182"></a>00182         Token <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#a7d3ba112a580e5bb912014b92cad0c70" title="The macro value.">Value</a>;
<a name="l00184"></a>00184         Token <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#a5f560cb50ebb7cab84b810bae354f710" title="Unparsed macro body (keeps the whole raw unparsed macro body)">Body</a>;
<a name="l00186"></a>00186         <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#ae90162d4139a15eab792aafd301e147d">Macro</a> *<a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#a76d7f64476e5a8d32333b9fb135d8573" title="Next macro in chained list.">Next</a>;
<a name="l00188"></a>00188         Token (*<a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#a1a494c322481277febe73cc37b7dc674" title="A pointer to function implementation (if macro is really a func)">ExpandFunc</a>) (<a class="code" href="classOgre_1_1CPreprocessor.html" title="This is a simplistic C/C++-like preprocessor.">CPreprocessor</a> *iParent, <span class="keywordtype">int</span> iNumArgs, Token *iArgs);
<a name="l00190"></a>00190         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#a6a67b68cac72a18e8e925b5728ee69c3" title="true if macro expansion is in progress">Expanding</a>;
<a name="l00191"></a>00191 
<a name="l00192"></a><a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#ae90162d4139a15eab792aafd301e147d">00192</a>         <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#ae90162d4139a15eab792aafd301e147d">Macro</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html" title="A input token.">Token</a> &amp;iName) :
<a name="l00193"></a>00193             <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#aaa4db807c57ea970482b85adb2f61b7b" title="Macro name.">Name</a> (iName), <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#af98d6c5e1e691dc809143ec71d07461b" title="Number of arguments.">NumArgs</a> (0), <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#ab5237af20d6e7d79920b264f6890de28" title="The names of the arguments.">Args</a> (NULL), <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#a76d7f64476e5a8d32333b9fb135d8573" title="Next macro in chained list.">Next</a> (NULL),
<a name="l00194"></a>00194             <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#a1a494c322481277febe73cc37b7dc674" title="A pointer to function implementation (if macro is really a func)">ExpandFunc</a> (NULL), <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#a6a67b68cac72a18e8e925b5728ee69c3" title="true if macro expansion is in progress">Expanding</a> (false)
<a name="l00195"></a>00195         { }
<a name="l00196"></a>00196 
<a name="l00197"></a><a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#a882e10e65ed20c49243b50f482787c66">00197</a>         <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#a882e10e65ed20c49243b50f482787c66">~Macro</a> ()
<a name="l00198"></a>00198         <span class="comment">//{ OGRE_DELETE [] Args; OGRE_DELETE Next; }</span>
<a name="l00199"></a>00199         { <span class="keyword">delete</span> [] <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#ab5237af20d6e7d79920b264f6890de28" title="The names of the arguments.">Args</a>; <span class="keyword">delete</span> <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#a76d7f64476e5a8d32333b9fb135d8573" title="Next macro in chained list.">Next</a>; }
<a name="l00200"></a>00200 
<a name="l00202"></a>00202         <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html" title="A input token.">Token</a> <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html#abae2519e560b6fdb67dce03bfc028e5b" title="Expand the macro value (will not work for functions)">Expand</a> (<span class="keywordtype">int</span> iNumArgs, <a class="code" href="classOgre_1_1CPreprocessor_1_1Token.html" title="A input token.">Token</a> *iArgs, <a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html" title="A macro definition.">Macro</a> *iMacros);
<a name="l00203"></a>00203     };
<a name="l00204"></a>00204 
<a name="l00205"></a>00205     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1CPreprocessor_1_1Macro.html" title="A macro definition.">CPreprocessor::Macro</a>;
<a name="l00206"></a>00206 
<a name="l00208"></a>00208     <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="classOgre_1_1CPreprocessor.html#a7dc31573de9dc2f77bf9cdd8483e9c47" title="The current source text input.">Source</a>;
<a name="l00210"></a>00210     <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="classOgre_1_1CPreprocessor.html#a822e0a0c63529dc94e6546b9055dd03b" title="The end of the source text.">SourceEnd</a>;
<a name="l00212"></a>00212     <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1CPreprocessor.html#a6aa8215b76abc8e5a9c2d604d2accb9a" title="Current line number.">Line</a>;
<a name="l00214"></a>00214     <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CPreprocessor.html#ae68f19bf20ad731317b05606e43dc97a" title="True if we are at beginning of line.">BOL</a>;
<a name="l00216"></a>00216     <span class="keywordtype">unsigned</span> <a class="code" href="classOgre_1_1CPreprocessor.html#aed088b4e9825cbaf441eaa9c6e0edffe" title="A stack of 32 booleans packed into one value :)">EnableOutput</a>;
<a name="l00218"></a>00218     Macro *<a class="code" href="classOgre_1_1CPreprocessor.html#af72ef2a02afa2a0bee42cf1063199f79" title="The list of macros defined so far.">MacroList</a>;
<a name="l00219"></a>00219 
<a name="l00223"></a>00223     <a class="code" href="classOgre_1_1CPreprocessor.html#a70001f3fef03cc20b5142e67702c3b3f" title="Create an empty preprocessor object.">CPreprocessor</a> (<span class="keyword">const</span> Token &amp;iToken, <span class="keywordtype">int</span> iLine);
<a name="l00224"></a>00224 
<a name="l00232"></a>00232     Token <a class="code" href="classOgre_1_1CPreprocessor.html#a86424507c9ad27b9f2dfe58af687337d" title="Stateless tokenizer: Parse the input text and return the next token.">GetToken</a> (<span class="keywordtype">bool</span> iExpand);
<a name="l00233"></a>00233 
<a name="l00243"></a>00243     Token <a class="code" href="classOgre_1_1CPreprocessor.html#a0aaad88f138b893ef1ebfa71ddc8adfa" title="Handle a preprocessor directive.">HandleDirective</a> (Token &amp;iToken, <span class="keywordtype">int</span> iLine);
<a name="l00244"></a>00244 
<a name="l00255"></a>00255     <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CPreprocessor.html#a3ead8f6089563cc58c2971df8f547d15" title="Handle a #define directive.">HandleDefine</a> (Token &amp;iBody, <span class="keywordtype">int</span> iLine);
<a name="l00256"></a>00256 
<a name="l00267"></a>00267     <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CPreprocessor.html#a31803eb25b17bca23e1b288f50b7f951" title="Undefine a previously defined macro.">HandleUnDef</a> (Token &amp;iBody, <span class="keywordtype">int</span> iLine);
<a name="l00268"></a>00268 
<a name="l00279"></a>00279     <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CPreprocessor.html#a0c8a33c1a96450035c6954c503b10e05" title="Handle an #ifdef directive.">HandleIfDef</a> (Token &amp;iBody, <span class="keywordtype">int</span> iLine);
<a name="l00280"></a>00280 
<a name="l00291"></a>00291     <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CPreprocessor.html#af76e82ceead20b3a15155f15ae1644fe" title="Handle an #if directive.">HandleIf</a> (Token &amp;iBody, <span class="keywordtype">int</span> iLine);
<a name="l00292"></a>00292 
<a name="l00303"></a>00303     <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CPreprocessor.html#a349fc959f355dea44ecb35060f5a371a" title="Handle an #else directive.">HandleElse</a> (Token &amp;iBody, <span class="keywordtype">int</span> iLine);
<a name="l00304"></a>00304 
<a name="l00315"></a>00315     <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CPreprocessor.html#ad2d95dc8ff84337b6b98fc557dbea6f1" title="Handle an #endif directive.">HandleEndIf</a> (Token &amp;iBody, <span class="keywordtype">int</span> iLine);
<a name="l00316"></a>00316 
<a name="l00327"></a>00327     Token <a class="code" href="classOgre_1_1CPreprocessor.html#aa22dc1c84c19c8e5fd512a86d625ad84" title="Get a single function argument until next &#39;,&#39; or &#39;)&#39;.">GetArgument</a> (Token &amp;oArg, <span class="keywordtype">bool</span> iExpand);
<a name="l00328"></a>00328 
<a name="l00339"></a>00339     Token <a class="code" href="classOgre_1_1CPreprocessor.html#aa8b0a1f8a1e5ad02557944304f9b68b1" title="Get all the arguments of a macro: &#39;(&#39; arg1 { &#39;,&#39; arg2 { &#39;,&#39; ...">GetArguments</a> (<span class="keywordtype">int</span> &amp;oNumArgs, Token *&amp;oArgs, <span class="keywordtype">bool</span> iExpand);
<a name="l00340"></a>00340 
<a name="l00354"></a>00354     Token <a class="code" href="classOgre_1_1CPreprocessor.html#a464dd5edb4fe05353f5d3e7ba4891ce3" title="Parse an expression, compute it and return the result.">GetExpression</a> (Token &amp;oResult, <span class="keywordtype">int</span> iLine, <span class="keywordtype">int</span> iOpPriority = 0);
<a name="l00355"></a>00355 
<a name="l00371"></a>00371     <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CPreprocessor.html#a561e0b06adcbb0ce06e0362cb94165a2" title="Get the numeric value of a token.">GetValue</a> (<span class="keyword">const</span> Token &amp;iToken, <span class="keywordtype">long</span> &amp;oValue, <span class="keywordtype">int</span> iLine);
<a name="l00372"></a>00372 
<a name="l00381"></a>00381     Token <a class="code" href="classOgre_1_1CPreprocessor.html#a99b76014f9760fcf4ee62235c19dc2bb" title="Expand the given macro, if it exists.">ExpandMacro</a> (<span class="keyword">const</span> Token &amp;iToken);
<a name="l00382"></a>00382 
<a name="l00390"></a>00390     Macro *<a class="code" href="classOgre_1_1CPreprocessor.html#af58ac5836a2327c1904a744d5113910d" title="Check if a macro is defined, and if so, return it.">IsDefined</a> (<span class="keyword">const</span> Token &amp;iToken);
<a name="l00391"></a>00391 
<a name="l00403"></a>00403     <span class="keyword">static</span> Token <a class="code" href="classOgre_1_1CPreprocessor.html#a324e1d364562292acb8c872234dd2df8" title="The implementation of the defined() preprocessor function.">ExpandDefined</a> (<a class="code" href="classOgre_1_1CPreprocessor.html" title="This is a simplistic C/C++-like preprocessor.">CPreprocessor</a> *iParent, <span class="keywordtype">int</span> iNumArgs, Token *iArgs);
<a name="l00404"></a>00404 
<a name="l00412"></a>00412     Token <a class="code" href="classOgre_1_1CPreprocessor.html#aa61f5214e59c7c18f0b87bd333d16564" title="Parse the input string and return a token containing the whole output.">Parse</a> (<span class="keyword">const</span> Token &amp;iSource);
<a name="l00413"></a>00413 
<a name="l00423"></a>00423     <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1CPreprocessor.html#af29a969505cfddcb84510036e6b80d26" title="Call the error handler.">Error</a> (<span class="keywordtype">int</span> iLine, <span class="keyword">const</span> <span class="keywordtype">char</span> *iError, <span class="keyword">const</span> Token *iToken = NULL);
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 <span class="keyword">public</span>:
<a name="l00427"></a><a class="code" href="classOgre_1_1CPreprocessor.html#a70001f3fef03cc20b5142e67702c3b3f">00427</a>     <a class="code" href="classOgre_1_1CPreprocessor.html#a70001f3fef03cc20b5142e67702c3b3f" title="Create an empty preprocessor object.">CPreprocessor</a> () : <a class="code" href="classOgre_1_1CPreprocessor.html#af72ef2a02afa2a0bee42cf1063199f79" title="The list of macros defined so far.">MacroList</a> (NULL)
<a name="l00428"></a>00428     { }
<a name="l00429"></a>00429 
<a name="l00431"></a>00431     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1CPreprocessor.html#a2b7c3b1a3208a27b36e87eee69464508" title="Destroy the preprocessor object.">~CPreprocessor</a> ();
<a name="l00432"></a>00432 
<a name="l00444"></a>00444     <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1CPreprocessor.html#a3026667d0f447d89bcac3fd8c6007a00" title="Define a macro without parameters.">Define</a> (<span class="keyword">const</span> <span class="keywordtype">char</span> *iMacroName, <span class="keywordtype">size_t</span> iMacroNameLen,
<a name="l00445"></a>00445                  <span class="keyword">const</span> <span class="keywordtype">char</span> *iMacroValue, <span class="keywordtype">size_t</span> iMacroValueLen);
<a name="l00446"></a>00446 
<a name="l00456"></a>00456     <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1CPreprocessor.html#a3026667d0f447d89bcac3fd8c6007a00" title="Define a macro without parameters.">Define</a> (<span class="keyword">const</span> <span class="keywordtype">char</span> *iMacroName, <span class="keywordtype">size_t</span> iMacroNameLen, <span class="keywordtype">long</span> iMacroValue);
<a name="l00457"></a>00457 
<a name="l00467"></a>00467     <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CPreprocessor.html#a3849848c4223928aea432f66184d541e" title="Undefine a macro.">Undef</a> (<span class="keyword">const</span> <span class="keywordtype">char</span> *iMacroName, <span class="keywordtype">size_t</span> iMacroNameLen);
<a name="l00468"></a>00468 
<a name="l00491"></a>00491     <span class="keywordtype">char</span> *<a class="code" href="classOgre_1_1CPreprocessor.html#aa61f5214e59c7c18f0b87bd333d16564" title="Parse the input string and return a token containing the whole output.">Parse</a> (<span class="keyword">const</span> <span class="keywordtype">char</span> *iSource, <span class="keywordtype">size_t</span> iLength, <span class="keywordtype">size_t</span> &amp;oLength);
<a name="l00492"></a>00492 
<a name="l00508"></a><a class="code" href="classOgre_1_1CPreprocessor.html#ab28e2d92b3f30f6d5237eb88b566cf2d">00508</a>     <span class="keyword">typedef</span> void (*<a class="code" href="classOgre_1_1CPreprocessor.html#ab28e2d92b3f30f6d5237eb88b566cf2d" title="An error handler function type.">ErrorHandlerFunc</a>) (
<a name="l00509"></a>00509         <span class="keywordtype">void</span> *iData, <span class="keywordtype">int</span> iLine, <span class="keyword">const</span> <span class="keywordtype">char</span> *iError,
<a name="l00510"></a>00510         <span class="keyword">const</span> <span class="keywordtype">char</span> *iToken, <span class="keywordtype">size_t</span> iTokenLen);
<a name="l00511"></a>00511 
<a name="l00517"></a>00517     <span class="keyword">static</span> <a class="code" href="classOgre_1_1CPreprocessor.html#ab28e2d92b3f30f6d5237eb88b566cf2d" title="An error handler function type.">ErrorHandlerFunc</a> <a class="code" href="classOgre_1_1CPreprocessor.html#ad9de8718668c27fbefe882fe08e4879a" title="A pointer to the preprocessor&#39;s error handler.">ErrorHandler</a>;
<a name="l00518"></a>00518 
<a name="l00520"></a>00520     <span class="keywordtype">void</span> *<a class="code" href="classOgre_1_1CPreprocessor.html#a9e0f513952ac2778f164fe178b826db7" title="User-specific storage, passed to Error()">ErrorData</a>;
<a name="l00521"></a>00521 };
<a name="l00522"></a>00522 
<a name="l00523"></a>00523 } <span class="comment">// namespace Ogre</span>
<a name="l00524"></a>00524 
<a name="l00525"></a>00525 <span class="preprocessor">#endif // __OGRE_CPREPROCESSOR_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
